if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientFormControl_A_ClientForm]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientFormControl] DROP CONSTRAINT FK_A_ClientFormControl_A_ClientForm
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientFormList_A_ClientForm]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientFormList] DROP CONSTRAINT FK_A_ClientFormList_A_ClientForm
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ClientFormRigths_A_ClientForm]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ClientFormRigths] DROP CONSTRAINT FK_A_ClientFormRigths_A_ClientForm
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Clients_ClientForms_A_ClientFormControl]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Clients_ClientForms] DROP CONSTRAINT FK_A_Clients_ClientForms_A_ClientFormControl
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Clients_ClientForms_A_Contragent]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Clients_ClientForms] DROP CONSTRAINT FK_A_Clients_ClientForms_A_Contragent
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Contragent_ContragentGroup_A_Contragent]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Contragent_ContragentGroup] DROP CONSTRAINT FK_A_Contragent_ContragentGroup_A_Contragent
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Contragent_KeyWords_A_Contragent]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Contragent_KeyWords] DROP CONSTRAINT FK_A_Contragent_KeyWords_A_Contragent
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ContragentContact_A_Contragent]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ContragentContact] DROP CONSTRAINT FK_A_ContragentContact_A_Contragent
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Contragent_ContragentGroup_A_ContragentGroup]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Contragent_ContragentGroup] DROP CONSTRAINT FK_A_Contragent_ContragentGroup_A_ContragentGroup
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_ContragentGroup_A_ContragentGroup]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_ContragentGroup] DROP CONSTRAINT FK_A_ContragentGroup_A_ContragentGroup
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[FK_A_Contragent_KeyWords_A_KeyWord]') and OBJECTPROPERTY(id, N'IsForeignKey') = 1)
ALTER TABLE [dbo].[A_Contragent_KeyWords] DROP CONSTRAINT FK_A_Contragent_KeyWords_A_KeyWord
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientForm]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientForm]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormControl]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormControl]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormList]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormList]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormRigths]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormRigths]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Clients_ClientForms]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Clients_ClientForms]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentContact]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentContact]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent_ContragentGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent_ContragentGroup]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent_KeyWords]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent_KeyWords]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_KeyWord]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_KeyWord]
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientForm]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientForm]
GO

CREATE TABLE [dbo].[A_ClientForm] (
	[idForm] [uniqueidentifier] NOT NULL ,
	[Name] [nvarchar] (255) COLLATE Cyrillic_General_CI_AS NOT NULL ,
	[ServerVersion] [datetime] NOT NULL ,
	[ClientVersion] [datetime] NOT NULL ,
	[idOwner] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormControl]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormControl]
GO

CREATE TABLE [dbo].[A_ClientFormControl] (
	[idFormControl] [uniqueidentifier] NOT NULL ,
	[Name] [nvarchar] (255) COLLATE Cyrillic_General_CI_AS NOT NULL ,
	[idForm] [uniqueidentifier] NOT NULL ,
	[idType] [int] NOT NULL ,
	[IsActual] [bit] NOT NULL 
) ON [PRIMARY]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormList]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormList]
GO

CREATE TABLE [dbo].[A_ClientFormList] (
	[idFormList] [uniqueidentifier] NOT NULL ,
	[idForm] [uniqueidentifier] NOT NULL ,
	[Name] [nvarchar] (50) COLLATE Cyrillic_General_CI_AS NOT NULL ,
	[IsActual] [bit] NOT NULL 
) ON [PRIMARY]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ClientFormRigths]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ClientFormRigths]
GO

CREATE TABLE [dbo].[A_ClientFormRigths] (
	[idForm] [uniqueidentifier] NOT NULL ,
	[idSubject] [uniqueidentifier] NOT NULL ,
	[isGroup] [bit] NOT NULL ,
	[AccessType] [tinyint] NOT NULL 
) ON [PRIMARY]
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Clients_ClientForms]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Clients_ClientForms]
GO

CREATE TABLE [dbo].[A_Clients_ClientForms] (
	[idValue] [uniqueidentifier] NOT NULL ,
	[idForm] [uniqueidentifier] NOT NULL ,
	[idFormList] [uniqueidentifier] NOT NULL ,
	[idFormControl] [uniqueidentifier] NOT NULL ,
	[idContragent] [uniqueidentifier] NOT NULL ,
	[ValueStr] [nvarchar] (2000) COLLATE Cyrillic_General_CI_AS NULL ,
	[ValueInt] [int] NULL ,
	[ValueDate] [datetime] NULL ,
	[ValueDate2] [datetime] NULL ,
	[ValueUsed] [varchar] (50) COLLATE Cyrillic_General_CI_AS NULL ,
	[idValueParent] [uniqueidentifier] NULL 
) ON [PRIMARY]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent]
GO

CREATE TABLE [dbo].[A_Contragent] (
	[idContragent] [uniqueidentifier] NOT NULL ,
	[Code] [nvarchar] (100) COLLATE Cyrillic_General_CI_AS NOT NULL ,
	[Name] [nvarchar] (250) COLLATE Cyrillic_General_CI_AS NOT NULL 
) ON [PRIMARY]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentContact]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentContact]
GO

CREATE TABLE [dbo].[A_ContragentContact] (
	[idContact] [uniqueidentifier] NOT NULL ,
	[idContragent] [uniqueidentifier] NOT NULL ,
	[Subscription] [nvarchar] (250) COLLATE Cyrillic_General_CI_AS NULL ,
	[Number] [nvarchar] (50) COLLATE Cyrillic_General_CI_AS NOT NULL ,
	[idType] [int] NOT NULL ,
	[IsDefault] [bit] NOT NULL 
) ON [PRIMARY]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_ContragentGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_ContragentGroup]
GO

CREATE TABLE [dbo].[A_ContragentGroup] (
	[idGroup] [uniqueidentifier] NOT NULL ,
	[idParent] [uniqueidentifier] NOT NULL ,
	[Name] [nvarchar] (250) COLLATE Cyrillic_General_CI_AS NOT NULL 
) ON [PRIMARY]
GO


if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent_ContragentGroup]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent_ContragentGroup]
GO

CREATE TABLE [dbo].[A_Contragent_ContragentGroup] (
	[idContragent] [uniqueidentifier] NOT NULL ,
	[idGroup] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_Contragent_KeyWords]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_Contragent_KeyWords]
GO

CREATE TABLE [dbo].[A_Contragent_KeyWords] (
	[idContragent] [uniqueidentifier] NOT NULL ,
	[idKeyWord] [uniqueidentifier] NOT NULL 
) ON [PRIMARY]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[A_KeyWord]') and OBJECTPROPERTY(id, N'IsUserTable') = 1)
drop table [dbo].[A_KeyWord]
GO


CREATE TABLE [dbo].[A_KeyWord] (
	[idKeyWord] [uniqueidentifier] NOT NULL ,
	[Name] [nvarchar] (250) COLLATE Cyrillic_General_CI_AS NOT NULL 
) ON [PRIMARY]
GO

ALTER TABLE [dbo].[A_ClientForm] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ClientForm] PRIMARY KEY  CLUSTERED 
	(
		[idForm]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ClientFormControl] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ClientFormControl] PRIMARY KEY  CLUSTERED 
	(
		[idFormControl]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ClientFormList] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ClientFormList] PRIMARY KEY  CLUSTERED 
	(
		[idFormList]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_Clients_ClientForms] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_Clients_ClientForms] PRIMARY KEY  CLUSTERED 
	(
		[idValue]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_Contragent] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_Contragent] PRIMARY KEY  CLUSTERED 
	(
		[idContragent]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ContragentContact] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ContragentContact] PRIMARY KEY  CLUSTERED 
	(
		[idContact]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ContragentGroup] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_ContragentGroup] PRIMARY KEY  CLUSTERED 
	(
		[idGroup]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_Contragent_ContragentGroup] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_Contragent_ContragentGroup] PRIMARY KEY  CLUSTERED 
	(
		[idContragent],
		[idGroup]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_Contragent_KeyWords] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_Contragent_KeyWords] PRIMARY KEY  CLUSTERED 
	(
		[idContragent],
		[idKeyWord]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_KeyWord] WITH NOCHECK ADD 
	CONSTRAINT [PK_A_KeyWord] PRIMARY KEY  CLUSTERED 
	(
		[idKeyWord]
	)  ON [PRIMARY] 
GO

ALTER TABLE [dbo].[A_ClientForm] WITH NOCHECK ADD 
	CONSTRAINT [DF_A_ClientForm_ServerVersion] DEFAULT (getdate()) FOR [ServerVersion],
	CONSTRAINT [DF_A_ClientForm_ClientVersion] DEFAULT (getdate()) FOR [ClientVersion]
GO

ALTER TABLE [dbo].[A_ClientFormControl] WITH NOCHECK ADD 
	CONSTRAINT [DF_A_ClientFormControl_IsActual] DEFAULT (1) FOR [IsActual]
GO

ALTER TABLE [dbo].[A_ClientFormList] WITH NOCHECK ADD 
	CONSTRAINT [DF_A_ClientFormList_IsActual] DEFAULT (1) FOR [IsActual]
GO

ALTER TABLE [dbo].[A_ClientFormRigths] WITH NOCHECK ADD 
	CONSTRAINT [DF_A_ClientFormRigths_isGroup] DEFAULT (0) FOR [isGroup],
	CONSTRAINT [DF_A_ClientFormRigths_Type] DEFAULT (1) FOR [AccessType]
GO

ALTER TABLE [dbo].[A_ContragentContact] WITH NOCHECK ADD 
	CONSTRAINT [DF_A_ContragentContact_IsDefault] DEFAULT (0) FOR [IsDefault]
GO


if exists ( select name from sysindexes where id=object_id('A_KeyWord') and impid >= 0 /*status!=0*/ and name not like '_WA%' and name like 'Name' )
	drop index A_KeyWord.Name
GO

CREATE  INDEX [Name] ON [dbo].[A_KeyWord]([Name]) WITH  FILLFACTOR = 80 ON [PRIMARY]
GO

ALTER TABLE [dbo].[A_ClientFormControl] ADD 
	CONSTRAINT [FK_A_ClientFormControl_A_ClientForm] FOREIGN KEY 
	(
		[idForm]
	) REFERENCES [dbo].[A_ClientForm] (
		[idForm]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_ClientFormList] ADD 
	CONSTRAINT [FK_A_ClientFormList_A_ClientForm] FOREIGN KEY 
	(
		[idForm]
	) REFERENCES [dbo].[A_ClientForm] (
		[idForm]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_ClientFormRigths] ADD 
	CONSTRAINT [FK_A_ClientFormRigths_A_ClientForm] FOREIGN KEY 
	(
		[idForm]
	) REFERENCES [dbo].[A_ClientForm] (
		[idForm]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_Clients_ClientForms] ADD 
	CONSTRAINT [FK_A_Clients_ClientForms_A_ClientFormControl] FOREIGN KEY 
	(
		[idFormControl]
	) REFERENCES [dbo].[A_ClientFormControl] (
		[idFormControl]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_A_Clients_ClientForms_A_Contragent] FOREIGN KEY 
	(
		[idContragent]
	) REFERENCES [dbo].[A_Contragent] (
		[idContragent]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_ContragentContact] ADD 
	CONSTRAINT [FK_A_ContragentContact_A_Contragent] FOREIGN KEY 
	(
		[idContragent]
	) REFERENCES [dbo].[A_Contragent] (
		[idContragent]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_ContragentGroup] ADD 
	CONSTRAINT [FK_A_ContragentGroup_A_ContragentGroup] FOREIGN KEY 
	(
		[idParent]
	) REFERENCES [dbo].[A_ContragentGroup] (
		[idGroup]
	) NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_Contragent_ContragentGroup] ADD 
	CONSTRAINT [FK_A_Contragent_ContragentGroup_A_Contragent] FOREIGN KEY 
	(
		[idContragent]
	) REFERENCES [dbo].[A_Contragent] (
		[idContragent]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_A_Contragent_ContragentGroup_A_ContragentGroup] FOREIGN KEY 
	(
		[idGroup]
	) REFERENCES [dbo].[A_ContragentGroup] (
		[idGroup]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

ALTER TABLE [dbo].[A_Contragent_KeyWords] ADD 
	CONSTRAINT [FK_A_Contragent_KeyWords_A_Contragent] FOREIGN KEY 
	(
		[idContragent]
	) REFERENCES [dbo].[A_Contragent] (
		[idContragent]
	) ON DELETE CASCADE  NOT FOR REPLICATION ,
	CONSTRAINT [FK_A_Contragent_KeyWords_A_KeyWord] FOREIGN KEY 
	(
		[idKeyWord]
	) REFERENCES [dbo].[A_KeyWord] (
		[idKeyWord]
	) ON DELETE CASCADE  NOT FOR REPLICATION 
GO

