if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_DB_RemoveTails' ) )
	Drop procedure dbo.A_DB_RemoveTails
GO

Create Procedure [dbo].[A_DB_RemoveTails] as
begin
--      .  ,    ..
		-----------------------------------------------------
		--    ----------------------------
		-----------------------------------------------------
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not (parentId in (Select [ID] From A_WorkPlaces))
		Delete From A_WorkPlaces where (type in (2,3,4,6)) and not ( LineId in ( Select [ID] From A_View_ServerIntLinesAll ))
		Delete From A_ServerExtLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerIntLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerGSMLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerSipLines where not [ServerID] in (Select [id] From A_WORKPLACES)
		Delete From A_ServerUSBLines where not [id] in (Select LineID From A_WORKPLACES)
		Delete From A_ServerVirtualLines where not [ServerID] in (Select [id] From A_WORKPLACES)	
		
		Delete From A_LinesReactors where not [WPID] in ( Select [id] From A_WORKPLACES )
		Delete From A_LinesReactors where not LineID in ( Select [ID] From A_View_ServerLinesAll )
		delete From A_ServerNumbers where not [id] in ( Select [ID] From A_WorkPlaces Where type=5 )
		delete From A_ServerNumbers where [id] in ( Select [ID] From A_WorkPlaces where hasdatabase>0 )



		Declare @t table(id_ uniqueidentifier)
		insert into @t
			Select [id] From A_WORKPLACES Union 
			Select [id] From A_Users union
			Select [id] From A_ExtNumbers union
			Select [id] From A_View_ServerLinesAll			

		
		Delete From A_RuleRecords where not RuleID in (Select ID From A_Rules)

		-- ,     
		Delete From A_RuleRecords where (InnerAddressType in (0,1)) and ( not ReactID in (Select id_ From @t ))
		-- ,   
		Delete From A_RuleRecords where (InnerAddressType in (3)) and ( not ReactID in (Select [Id] From A_ServerStreams ))

		Delete From A_NumberPlanAction where numtype=0 and extraid not in (Select ID From A_Rules)
		delete From A_NumberPlan where id not in (Select numid From A_NumberPlanAction)
		Delete From A_RuleRecords where InnerAddressType=2 and not ReactID in (Select ID From A_NumberPlan)
		Delete From A_Rules	Where not id in ( Select ruleid From A_RuleRecords )		

		delete From A_TaskManager_TaskExtLines where not ExtLineId in ( Select id From A_ServerExtLines )
		delete From A_TaskManager_Operators where not OperatorId in ( Select id From A_Users Union Select Id From C_Groups )

		-----------------------------------------------------
		--     =   -   
		-----------------------------------------------------
		Declare @svraddr nvarchar ( 100 )
		Select @svraddr = Address 
		From A_WorkPlaces
		Where HasFastEngine = 1
		Update A_WorkPlaces Set Address = '  ' 
		Where Address like @svraddr and HasFastEngine = 0

		-----------------------------------------------------
		-- Null  0  ID    ----------------
		-----------------------------------------------------
		Update A_ServerIntLines
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where DefaultUserId is null

		-----------------------------------------------------
		--  0     -----------
		-----------------------------------------------------
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		Where not DefaultUserId in (Select id From A_Users)

		-----------------------------------------------------
		--         --
		-----------------------------------------------------
		Declare @useddefusers table (id uniqueidentifier)
		Declare @idtozero table (id uniqueidentifier)
		Declare @lid uniqueidentifier
		Declare @uid uniqueidentifier
		Declare @tmp bit 		

		Declare defusercur Cursor For
			Select Id, DefaultUserId 
			From A_View_ServerIntLinesDefaultUsers
			Where DefaultUserId != '00000000-0000-0000-0000-000000000000'

		Open defusercur
		Fetch Next From defusercur Into @lid, @uid
		While @@FETCH_STATUS = 0
		Begin		
			Select @tmp = 1 From @useddefusers where id = @uid
			if ( @tmp > 0 )
				Insert Into @idtozero (id) values (@lid)
			else
				Insert Into @useddefusers (id) values (@uid)
			Fetch Next From defusercur  Into @lid, @uid
		End
		Close defusercur
		Deallocate defusercur
		
		Update A_ServerIntLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerIntLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerSipLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerSipLines si, @idtozero iz
		Where si.Id = iz.Id

		Update A_ServerVirtualLines 
		Set DefaultUserId = '00000000-0000-0000-0000-000000000000'
		From A_ServerVirtualLines si, @idtozero iz
		Where si.Id = iz.Id
		
		-----------------------------------------------------
		--    ------------------
		-----------------------------------------------------
		Begin Tran UIT

		Delete From A_TaskManager_UserInTask with ( TabLock, HoldLock )
		Where not exists ( Select Id From A_Users Where A_Users.Id = UserId )

		Delete From A_TaskManager_UserInTask --with ( TabLock )
		Where not exists ( Select Id From A_TaskManager_Tasks Where A_TaskManager_Tasks.Id = TaskId )
		
		Commit tran UIT


		Delete From A_TaskManager_Operators
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_TaskExtLines
		Where not exists ( Select Id From A_TaskManager_Tasks where A_TaskManager_Tasks.Id = TaskId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not exists ( Select Id From C_Groups where C_Groups.Id = OperatorId )

		Delete From A_TaskManager_Operators
		Where IsGroup = 1 and not Exists ( Select * From A_Users where A_Users.Id = OperatorId )
		

		Declare @uidt table ( id uniqueidentifier )
		Insert into @uidt
			Select Id From A_Users
		Delete From A_UserControls
		Where not UserA in (Select id From @uidt)
			or not UserB in (Select id From @uidt)

		-----------------------------------------------------
		--     --------------------
		-----------------------------------------------------
		Delete 
		From A_Redirect
		Where IdUser not in ( Select Id From A_Users )

		-----------------------------------------------------
		--   ------------------------------------
		-----------------------------------------------------
		exec A_Admin_UserGroup_Group_SiftEmpty		

		-----------------------------------------------------
		--   ------------------------------
		-----------------------------------------------------
		Delete From A_UserRoles 
		Where creationtype != 0 
			and not exists ( Select IdRole From A_UserParams up Where up.IdRole = A_UserRoles.Id )
		Delete From A_UserRolesExt 
		Where not exists ( Select Id From A_UserRoles a where a.Id = IdRole )

		-----------------------------------------------------
		--   ------------------------------
		-----------------------------------------------------	
		Delete from A_WorkPlace_Address

end
GO

