if exists ( Select * From sysobjects where id = object_id ( 'dbo.A_Settings_Save' ) )
	Drop procedure dbo.A_Settings_Save
GO

Create Procedure [dbo].[A_Settings_Save]
	@name nvarchar ( 255 ),
	@valstr nvarchar ( 4000 ),
	@valint int,
	@valdouble float
as
begin
	Update A_Settings
	Set 	valuestr = @valstr, 
		valueint = @valint
	Where [Name] like @name

	if ( @@rowcount = 0 )
		Insert 
		Into A_Settings ( [Name], ValueStr, ValueInt, ValueDouble )
		Values ( @name, @valstr, @valint, @valdouble )
end
GO

