if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_ControlEvents' ) )
	drop table dbo.A_CallCenter_ControlEvents
GO

Create table dbo.A_CallCenter_ControlEvents 
(
	Id uniqueidentifier not null primary key,
	Name nvarchar ( 500 ),
	Type int,
	Type2 int,
	Active bit,
	Stream image,
	IsDeleted bit
)
GO

if exists ( Select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_ControlEvents_LoadAll' ) )
	drop procedure dbo.A_CallCenter_ControlEvents_LoadAll
GO

Create procedure dbo.A_CallCenter_ControlEvents_LoadAll
as
begin

	Select Id, Type, Type2, Active, DataLength(Stream) as Length, Stream 
	From A_CallCenter_ControlEvents
end
GO

