if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[crosstab]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[crosstab]
GO

CREATE  PROCEDURE crosstab 
@source varchar(1000), --,   FROM  WHERE
@fields varchar(100)=null, --  ...    .   ,      -    
@func varchar(500), --   sum(some_field), count...    ...      * ()
@pivot1 varchar(1000), --    
@filtr varchar(1000)=null, --   (,      WHERE)
@into varchar(100)=null, -- ,         ()
@bracket_diff int=0
AS
begin
DECLARE 
@select VARCHAR(8000), 
@sql VARCHAR(8000), 
@sql1 VARCHAR(8000), 
@sql2 VARCHAR(8000), 
@sql3 VARCHAR(8000), 
@sql4 VARCHAR(8000), 
@sql5 VARCHAR(8000), 
@sql6 VARCHAR(8000), 
@sql7 VARCHAR(8000), 
@sql8 VARCHAR(8000), 
@sql9 VARCHAR(8000), 
@sqlend VARCHAR(8000), 
@delim VARCHAR(1), 
@sqllen numeric(10), 
@sqlnum numeric(10), 
@pvalue VARCHAR(100),
@filtr1 varchar(1000) 

SET NOCOUNT ON
SET ANSI_WARNINGS OFF

SET @filtr1=isnull(' AND '+@filtr, '')

IF Exists( Select * from tempdb.INFORMATION_SCHEMA.Tables Where Table_Name = @into )
	EXEC ( 'drop table ' + @into )

EXEC ('SELECT DISTINCT ' + @pivot1 + ' as pivot1 INTO ##pivot1 FROM ' + @source + ' WHERE ' 
+ @pivot1 + ' Is Not Null '+ @filtr1)

print @func
SELECT @sql='',
@sql1='',
@sql2='',
@sql3='',
@sql4='',
@sql5='',
@sql6='',
@sql7='',
@sql8='',
@sql9='',
@select='SELECT '+isnull(@fields+',',''),  
@func=stuff(@func, len(@func)-@bracket_diff, 1, ' END)')
print @func

SELECT top 1 @delim = CASE ISNUMERIC([pivot1]) WHEN 1 THEN '' ELSE '''' END FROM ##pivot1
DECLARE cur_pivot_cursor scroll CURSOR FOR select [pivot1] from ##pivot order by [pivot1]  

OPEN cur_pivot_cursor

if @@CURSOR_ROWS = 0 BEGIN
 IF Exists( Select * from tempdb.INFORMATION_SCHEMA.Tables Where Table_Name = @into )
	EXEC ( 'drop table ' + @into )
 Drop table ##pivot1
 CLOSE cur_pivot_cursor
 DEALLOCATE cur_pivot_cursor
 return
END

FETCH NEXT FROM cur_pivot_cursor
INTO @pvalue
	
SET @sqlnum = 1

WHILE @@FETCH_STATUS = 0

BEGIN

--   
declare @bracketpos int
select @bracketpos = case 
			when charindex( 'sum(', @func ) > 0 then charindex( 'sum(', @func )+3
			when charindex( 'min(', @func ) > 0 then charindex( 'min(', @func )+3
			when charindex( 'max(', @func ) > 0 then charindex( 'max(', @func )+3
			when charindex( 'avg(', @func ) > 0 then charindex( 'avg(', @func )+3
			when charindex( 'count(', @func ) > 0 then charindex( 'count(', @func )+5
			else charindex( '(', @func ) 
		     end

SET @sql=@sql + '''' + convert(VARCHAR(100), @pvalue) + ''' = ' + 
stuff(@func,@bracketpos+1, 0, 'CASE ' + @pivot1 + 
' WHEN ' + @delim + convert(VARCHAR(100), @pvalue) + @delim + ' THEN ' ) + ', '

--   
SET @sqllen = len(@sql)

--   ,   , 
-- 1- 
IF @sqllen > 7800 and @sqlnum = 1 
BEGIN
SET @sql1 = @sql
SET @sqlnum = @sqlnum + 1
SET @sql = ''
SET @sqllen = 0
END

-- 2- 
IF @sqllen > 7800 and @sqlnum = 2
BEGIN
SET @sql2 = @sql
SET @sqlnum = @sqlnum + 1
SET @sql = ''
SET @sqllen = 0
END

-- 3- 
IF @sqllen > 7800 and @sqlnum = 3
BEGIN
SET @sql3 = @sql
SET @sqlnum = @sqlnum + 1
SET @sql = ''
SET @sqllen = 0
END

-- 4- 
IF @sqllen > 7800 and @sqlnum = 4
BEGIN
SET @sql4 = @sql
SET @sqlnum = @sqlnum + 1
SET @sql = ''
SET @sqllen = 0
END

-- 5- 
IF @sqllen > 7800 and @sqlnum = 5 
BEGIN
SET @sql5 = @sql
SET @sqlnum = @sqlnum + 1
SET @sql = ''
SET @sqllen = 0
END

-- 6- 
IF @sqllen > 7800 and @sqlnum = 6
BEGIN
SET @sql6 = @sql
SET @sqlnum = @sqlnum + 1
SET @sql = ''
SET @sqllen = 0
END

-- 7- 
IF @sqllen > 7800 and @sqlnum = 7
BEGIN
SET @sql7 = @sql
SET @sqlnum = @sqlnum + 1
SET @sql = ''
SET @sqllen = 0
END 
-- 8- 
IF @sqllen > 7800 and @sqlnum = 8
BEGIN
SET @sql8 = @sql
SET @sqlnum = @sqlnum + 1
SET @sql = ''
SET @sqllen = 0
END 

-- 9- 
IF @sqllen > 7800 and @sqlnum = 9
BEGIN
SET @sql9 = @sql
SET @sqlnum = @sqlnum + 1
SET @sql = ''
SET @sqllen = 0
END 

--   
FETCH NEXT FROM cur_pivot_cursor
INTO @pvalue

END

--    
CLOSE cur_pivot_cursor
DEALLOCATE cur_pivot_cursor

DROP TABLE ##pivot1

--        
IF len(@sql) > 0
SELECT @sql=left(@sql, len(@sql)-1)
ELSE 
BEGIN
IF LEN(@sql9)>0SELECT @sql9=left(@sql9, len(@sql9)-1)
ELSE IF LEN(@sql8)>0
SELECT @sql8=left(@sql8, len(@sql9)-1)
ELSE IF LEN(@sql7)>0
SELECT @sql7=left(@sql7, len(@sql7)-1)
ELSE IF LEN(@sql6)>0
SELECT @sql6=left(@sql6, len(@sql6)-1)
ELSE IF LEN(@sql5)>0
SELECT @sql5=left(@sql5, len(@sql5)-1)
ELSE IF LEN(@sql4)>0
SELECT @sql4=left(@sql4, len(@sql4)-1)
ELSE IF LEN(@sql3)>0
SELECT @sql3=left(@sql3, len(@sql3)-1)
ELSE IF LEN(@sql2)>0
SELECT @sql2=left(@sql2, len(@sql2)-1)
ELSE IF LEN(@sql1)>0
SELECT @sql1=left(@sql1, len(@sql1)-1)
END
SET @filtr1=isnull(' WHERE '+@filtr, '')
set @sqlend=isnull(' INTO '+@into,'')+' FROM '+@source+@filtr1+isnull(' GROUP BY '+@fields,'')

EXEC (@select+@sql1+@sql2+@sql3+@sql4+@sql5+@sql6+@sql7+@sql8+@sql9+@sql+@sqlend)

--print @select+@sql1+@sql2+@sql3+@sql4+@sql5+@sql6+@sql7+@sql8+@sql9+@sql+@sqlend
--EXEC( 'select * from ' + @into)
--EXEC ( 'drop table ' + @into )
end
GO





if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Report1_3]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[Report1_3]
GO


CREATE PROCEDURE Report1_3 
@@dtbegin datetime,
@@dtend  datetime,
@@OperatorId uniqueidentifier ,
@@interval int
-- 1 = 30 
-- 2 = 1  
-- 3 = 3 
-- 4 = 1 
-- 5 = 1 
-- 6 = 1 

AS

set dateformat dmy
set fmtonly off
----
--set @@interval = 2
--set  @@dtbegin = '01.03.2008 11:14:13'
--set @@dtend = getdate()
--set @@OperatorId = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8'
----z
 
-- 
declare @@dtbegin1 datetime, @@dtend1 datetime
CREATE TABLE #table_intervals( id int identity(1,1), name varchar(50) collate database_default, datebegin datetime, dateend datetime primary key(datebegin, dateend)  )
set @@dtbegin1 = @@dtbegin
while @@dtbegin1 < @@dtend begin

select @@dtend1 = case @@interval
			   when 1 then dateadd( minute, 30, @@dtbegin1 )
			   when 2 then dateadd( hour, 1, @@dtbegin1 ) 
			   when 3 then dateadd( hour, 3, @@dtbegin1 )
			   when 4 then dateadd( day, 1, @@dtbegin1 )
			   when 5 then dateadd( week, 1, @@dtbegin1 )
			   when 6 then dateadd( month, 1, @@dtbegin1 )
			   else dateadd( month, 1, @@dtbegin1 )
			  end
insert #table_intervals( name, datebegin, dateend )
select case @@interval
	   when 1 then convert ( varchar(19), @@dtbegin1, 104 ) + ' ' + convert ( varchar(5), @@dtbegin1, 108 ) + ' - ' + convert ( varchar(5), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 108 )
	   when 2 then convert ( varchar(19), @@dtbegin1, 104 ) + ' ' + convert ( varchar(5), @@dtbegin1, 108 ) + ' - ' + convert ( varchar(5), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 108 )
	   when 3 then convert ( varchar(19), @@dtbegin1, 104 ) + ' ' + convert ( varchar(5), @@dtbegin1, 108 ) + ' - ' + convert ( varchar(5), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 108 )
	   when 4 then convert ( varchar(10), @@dtbegin1, 104 ) + ' - ' + convert ( varchar(10), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 104 )
	   when 5 then convert ( varchar(10), @@dtbegin1, 104 ) + ' - ' + convert ( varchar(10), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 104 )
	   when 6 then convert ( varchar(10), @@dtbegin1, 104 ) + ' - ' + convert ( varchar(10), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 104 )
	   else convert ( varchar(10), @@dtbegin1, 104 ) + ' - ' + convert ( varchar(10), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 104 )
       end,
 @@dtbegin1, case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end
set @@dtbegin1 = @@dtend1
end

--select * from #table_intervals

--       
select tt.Id as 'IntervalId',
LenTime, DateTimeStart, DateTimeStop, State, ICode
into #t0
from oktell_cc_temp..A_Cube_CC_OperatorStates cubetb
 inner join #table_intervals tt 
on ( tt.datebegin between cubetb.DateTimeStart and cubetb.DateTimeStop )
	or ( tt.dateend between cubetb.DateTimeStart and cubetb.DateTimeStop )
	or ( cubetb.DateTimeStart between tt.datebegin and tt.dateend )
	or ( cubetb.DateTimeStop between tt.datebegin and tt.dateend )
where DateTimeStart >= @@dtbegin and DateTimeStop <= @@dtend 	
and IdOperator = @@OperatorId

--select * from #table_intervals
--select * from #t0 where Icode is not null

--1   ( )

--1   ( )


--select Id, Name from oktell..A_TaskManager_CardLunchStates
--  (  )
EXEC crosstab
'#t0 a INNER JOIN oktell..A_TaskManager_CardLunchStates b ON a.ICode=b.id INNER JOIN  #table_intervals ti on ti.id = a.IntervalId',
'a.IntervalId', 
'dbo.DoubleSecondsToData ( sum( dbo.CalcLenTimeByInterval( DateTimeStart, DateTimeStop, ti.datebegin, ti.dateend ) ) )', 
'b.Name', 	
'a.State = 9 and exists( select Id from oktell..A_TaskManager_CardLunchStates where Id = a.ICode )', 
'##temp',
2

if not exists( Select * from tempdb.INFORMATION_SCHEMA.Tables Where Table_Name = '##temp' )
 return
--  ( )
select  gr.Interval  AS '', 
	gr.FirstInputTime  AS '   call-', 
	gr.LastOutputTime  AS '   call-', gr.DurationInCC AS '   call-', 
	gr.DurationLunchReglament AS '  ',  tt.*, gr.DurationLunchTotal AS '  '
from 
	(select top 100 percent 
	tt.IntervalId, 
	( Select Name from #table_intervals where id = tt.IntervalId ) As 'Interval', 
	convert( varchar, Min( DateTimeStart ), 104 )+ ' ' + convert( varchar, Min( DateTimeStart ), 108 ) + case when count( * ) > 1 then '*' else '' end as 'FirstInputTime',
	convert( varchar, Max( DateTimeStop ), 104 )+ ' ' + convert( varchar, Max( DateTimeStop ), 108 ) + case when count( * ) > 1 then '*' else '' end as 'LastOutputTime', 
	dbo.DoubleSecondsToData ( sum( dbo.CalcLenTimeByInterval( DateTimeStart, DateTimeStop, ti.datebegin, ti.dateend ) ) ) as 'DurationInCC',
	dbo.DoubleSecondsToData ( IsNull( ( select sum( dbo.CalcLenTimeByInterval( DateTimeStart, DateTimeStop, ti.datebegin, ti.dateend ) )
		  from #t0 t0 
			inner join #table_intervals ti on ti.id = t0.IntervalId
		  where State = 9 and not exists( select Id from oktell..A_TaskManager_CardLunchStates where Id = t0.ICode ) and IntervalId = tt.IntervalId
		  group by IntervalId ), 0 ) ) As 'DurationLunchReglament',
	--   
	dbo.DoubleSecondsToData (IsNull( ( select sum( dbo.CalcLenTimeByInterval( DateTimeStart, DateTimeStop, ti.datebegin, ti.dateend ) ) 		  from #t0 t0 
			inner join #table_intervals ti on ti.id = t0.IntervalId
		  where State = 9 and IntervalId = tt.IntervalId
		  group by IntervalId ), 0 ) ) As 'DurationLunchTotal'
	from #t0 tt
		inner join #table_intervals ti on ti.id = tt.IntervalId
	group by IntervalId
	order by IntervalId) gr 
		left join ##temp tt on gr.IntervalId = tt.IntervalId

drop table #t0
DROP TABLE #table_intervals
drop table ##temp

SET ANSI_WARNINGS ON	
GO





if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[Report1_4]') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure [dbo].[Report1_4]
GO


CREATE PROCEDURE Report1_4
@@dtbegin datetime,
@@dtend  datetime,
@@OperatorId uniqueidentifier ,
@@interval int
-- 1 = 30 
-- 2 = 1  
-- 3 = 3 
-- 4 = 1 
-- 5 = 1 
-- 6 = 1 

AS

set dateformat dmy
set fmtonly off
----
--set @@interval = 2
--set  @@dtbegin = '01.03.2008 11:14:13'
--set @@dtend = getdate()
--set @@OperatorId = 'DA803F01-EA77-40FA-BC9D-E2EFB36FD5A8'
----z
 
-- 
declare @@dtbegin1 datetime, @@dtend1 datetime
declare @table_intervals table( id int identity(1,1), name varchar(50), datebegin datetime, dateend datetime primary key(datebegin, dateend)  )
set @@dtbegin1 = @@dtbegin
while @@dtbegin1 < @@dtend begin

select @@dtend1 = case @@interval
			   when 1 then dateadd( minute, 30, @@dtbegin1 )
			   when 2 then dateadd( hour, 1, @@dtbegin1 ) 
			   when 3 then dateadd( hour, 3, @@dtbegin1 )
			   when 4 then dateadd( day, 1, @@dtbegin1 )
			  when 5 then dateadd( week, 1, @@dtbegin1 )
			   when 6 then dateadd( month, 1, @@dtbegin1 )
			  end
insert @table_intervals( name, datebegin, dateend )
select case @@interval
	   when 1 then convert ( varchar(19), @@dtbegin1, 104 ) + ' ' + convert ( varchar(5), @@dtbegin1, 108 ) + ' - ' + convert ( varchar(5), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 108 )
	   when 2 then convert ( varchar(19), @@dtbegin1, 104 ) + ' ' + convert ( varchar(5), @@dtbegin1, 108 ) + ' - ' + convert ( varchar(5), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 108 )
	   when 3 then convert ( varchar(19), @@dtbegin1, 104 ) + ' ' + convert ( varchar(5), @@dtbegin1, 108 ) + ' - ' + convert ( varchar(5), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 108 )
	   when 4 then convert ( varchar(10), @@dtbegin1, 104 ) + ' - ' + convert ( varchar(10), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 104 )
	   when 5 then convert ( varchar(10), @@dtbegin1, 104 ) + ' - ' + convert ( varchar(10), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 104 )
	   when 6 then convert ( varchar(10), @@dtbegin1, 104 ) + ' - ' + convert ( varchar(10), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 104 )
	   else convert ( varchar(10), @@dtbegin1, 104 ) + ' - ' + convert ( varchar(10), case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end , 104 )
       end,
	@@dtbegin1, case when @@dtend1 < @@dtend then @@dtend1 else @@dtend end
set @@dtbegin1 = @@dtend1
end

--select * from @table_intervals

--       
select tt.Id as IntervalId,
LenTime, DateTimeStart, DateTimeStop, State, ICode
into #t0
from oktell_cc_temp..A_Cube_CC_OperatorStates cubetb
 inner join @table_intervals tt 
on ( tt.datebegin between cubetb.DateTimeStart and cubetb.DateTimeStop )
	or ( tt.dateend between cubetb.DateTimeStart and cubetb.DateTimeStop )
	or ( cubetb.DateTimeStart between tt.datebegin and tt.dateend )
	or ( cubetb.DateTimeStop between tt.datebegin and tt.dateend )
where DateTimeStart >= @@dtbegin and DateTimeStop <= @@dtend 	
and IdOperator = @@OperatorId

--  ( )
select ( select name from @table_intervals where id = tt.IntervalId) as 'Interval', 
convert( varchar, Min( DateTimeStart ), 104 )+ ' ' + convert( varchar, Min( DateTimeStart ), 108 ) + case when count( * ) > 1 then '*' else '' end as 'FirstInputTime', 
convert( varchar, Max( DateTimeStop ), 104 )+ ' ' + convert( varchar, Max( DateTimeStop ), 108 ) + case when count( * ) > 1 then '*' else '' end as 'LastOutputTime', 
dbo.DoubleSecondsToData ( sum( dbo.CalcLenTimeByInterval( DateTimeStart, DateTimeStop, ti.datebegin, ti.dateend ) ) ) as 'DurationInCC',
dbo.DoubleSecondsToData ( IsNull( Max( DurationLunchReglament ), 0 ) ) As 'DurationLunchReglament',
dbo.DoubleSecondsToData ( IsNull( Max( DurationLunchOther ), 0 ) ) As 'DurationLunchOther',
dbo.DoubleSecondsToData ( IsNull( Max( DurationLunchReglament + DurationLunchOther ), 0 ) ) As 'DurationLunchTotal',
dbo.DoubleSecondsToData ( sum( dbo.CalcLenTimeByInterval( DateTimeStart, DateTimeStop, ti.datebegin, ti.dateend ) ) 
  - IsNull( Max( DurationLunchReglament ), 0 ) ) As 'WorkedTime'
from #t0 tt
 left join ( select IntervalId, sum( dbo.CalcLenTimeByInterval( DateTimeStart, DateTimeStop, ti.datebegin, ti.dateend ) ) as 'DurationLunchReglament'
	  from #t0 t0 
		inner join @table_intervals ti on ti.id = t0.IntervalId
	  where State = 9 and not exists( select Id from oktell..A_TaskManager_CardLunchStates where Id = t0.ICode )
	  group by IntervalId ) gr1 on gr1.IntervalId = tt.IntervalId
 left join ( select IntervalId, sum( dbo.CalcLenTimeByInterval( DateTimeStart, DateTimeStop, ti.datebegin, ti.dateend ) ) as 'DurationLunchOther'
	  from #t0 t0 
		inner join @table_intervals ti on ti.id = t0.IntervalId
	  where State = 9 and exists( select Id from oktell..A_TaskManager_CardLunchStates where Id = t0.ICode )
	  group by IntervalId ) gr2 on gr2.IntervalId = tt.IntervalId
 inner join @table_intervals ti on ti.id = tt.IntervalId
group by tt.IntervalId
order by tt.IntervalId



SET ANSI_WARNINGS ON

GO






if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[CalcLenTimeByInterval]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[CalcLenTimeByInterval]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[DoubleSecondsToData]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[DoubleSecondsToData]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[GetDate]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[GetDate]
GO

if exists (select * from dbo.sysobjects where id = object_id(N'[dbo].[GetTime]') and xtype in (N'FN', N'IF', N'TF'))
drop function [dbo].[GetTime]
GO


CREATE  FUNCTION [dbo].[CalcLenTimeByInterval] (@DateStart datetime, @DateEnd datetime, @DateIntervalStart datetime, @DateIntervalEnd datetime)  
RETURNS decimal(10,2) AS  
BEGIN 
declare @basedt datetime
set @basedt = '00:00:00' if( @DateStart >= @DateIntervalStart and @DateEnd <= @DateIntervalEnd )
   return DateDiff( second, @DateStart, @DateEnd )
 else if( @DateStart >= @DateIntervalStart and @DateEnd >= @DateIntervalEnd )
   return DateDiff( second, @DateStart, @DateIntervalEnd )
 else if( @DateStart <= @DateIntervalStart and @DateEnd <= @DateIntervalEnd )
   return DateDiff( second, @DateIntervalStart, @DateEnd )
 else if( @DateStart <= @DateIntervalStart and @DateEnd >= @DateIntervalEnd )
   return DateDiff( second, @DateIntervalStart, @DateIntervalEnd ) 
 return 0
END

GO


CREATE   FUNCTION [dbo].[DoubleSecondsToData] (@DbData decimal(10,2))  
RETURNS varchar(8) AS  
BEGIN 
declare @basedt datetime
set @basedt = '00:00:00'return Convert( varchar(8), DateAdd( second, @DbData , @basedt ), 108 )

END
GO



CREATE   FUNCTION [dbo].[GetDate] (@@Date datetime)  
RETURNS datetime AS  
BEGIN 
  return convert( datetime, convert( varchar, @@Date, 104 ) )
END

GO



CREATE  FUNCTION [dbo].[GetTime] (@@Date datetime)  
RETURNS datetime AS  
BEGIN 
  return convert( datetime, convert( varchar, @@Date, 108 ) )
END

GO



if exists (select * from dbo.sysobjects where id = object_id('dbo.A_CallCenter_Report_GetSProcNames') and OBJECTPROPERTY(id, N'IsProcedure') = 1)
drop procedure dbo.[A_CallCenter_Report_GetSProcNames]
GO


Create Procedure dbo.[A_CallCenter_Report_GetSProcNames]
as
begin tran
create table #res ( id int identity(1,1), namedb varchar(256) collate database_default, namesp varchar(256) collate database_default )

declare cr_db cursor local FAST_FORWARD READ_ONLY
FOR 
select name 
from master..sysdatabases
where name not in ('master','model','tempdb','msdb') 
declare @dbname varchar(255), @spname varchar(255)
declare @sqltext varchar(1000)
open cr_db

fetch next from cr_db into @dbname

while @@fetch_status = 0 begin
--use @dbname
set @sqltext = 'insert #res ( namedb, namesp )
          select ''' + @dbname + ''',name
          from '+ @dbname + '..sysobjects
          where xtype = ''P''
          order by Name'
--print @sqltext
exec sp_sqlexec @sqltext 
          

fetch next from cr_db into @dbname
end

select * from #res
drop table #res

close cr_db
deallocate cr_db
commit

GO