if exists ( select * FROM sysobjects where id = object_id ( 'dbo.A_CallCenter_Office_Contragents_SaveGroup' ) )
	drop procedure dbo.A_CallCenter_Office_Contragents_SaveGroup
GO

Create Procedure [dbo].[A_CallCenter_Office_Contragents_SaveGroup]
@@idContragent uniqueidentifier,
@@idGroup uniqueidentifier,
@@idGroupParent uniqueidentifier,
@@Name nvarchar(512)
as
begin	

--Voc
if( not exists( select idGroup from A_ContragentGroup where idGroup = @@idGroup ) )
 insert A_ContragentGroup ( idGroup, idParent, [Name] )
	values( @@idGroup, @@idGroupParent, @@Name )
else
 update A_ContragentGroup 
	set idParent = @@idGroupParent, [Name] = @@Name
	where idGroup = @@idGroup

if( @@idContragent != '00000000-0000-0000-0000-000000000000') --      
	if( not exists( select idGroup from A_Contragent_ContragentGroup where idContragent = @@idContragent and idGroup = @@idGroup ) )
	 insert A_Contragent_ContragentGroup ( idContragent, idGroup )
		values ( @@idContragent, @@idGroup )

end
GO