if exists ( select * from sysobjects where id = object_id ( 'dbo.A_DB_ClearConstraintsAll' ) )
	drop procedure dbo.A_DB_ClearConstraintsAll
GO

Create  procedure [dbo].[A_DB_ClearConstraintsAll]
	@simpletablename nvarchar ( 500 )
as
begin
	
declare @tablename varchar ( 500 )
declare @sql nvarchar(1000)
set @tablename='dbo.' + @simpletablename


DECLARE tcursor CURSOR FOR 
	select s.name, s.parent_obj, s1.name
	from sysobjects s
		inner join sysobjects s1 on s.parent_obj = s1.Id
	where ( s.type = 'F' or s.type = 'K' ) and s.name like '%' + @simpletablename + '%' 

declare @cnstrname varchar(500)
declare @parent int
declare @subtab varchar ( 500 )


OPEN tcursor
FETCH NEXT FROM tcursor INTO @cnstrname, @parent, @subtab

WHILE @@FETCH_STATUS = 0
BEGIN

set @sql = ' ALTER TABLE ' + @subtab + 
	' DROP CONSTRAINT ' + @cnstrname
exec sp_executesql @stmt =@sql
print @sql

FETCH NEXT FROM tcursor INTO @cnstrname, @parent, @subtab
END

CLOSE tcursor
DEALLOCATE tcursor

end
GO

