if exists ( Select * FROM oktell_cc_temp..sysobjects where id = object_id ( 'oktell_cc_temp.dbo.A_Sms' ) )
if not Exists ( Select * From oktell_cc_temp.INFORMATION_SCHEMA.Columns Where TABLE_NAME like 'A_Sms' 
								and TABLE_SCHEMA like 'dbo'
								and COLUMN_NAME like 'IdServer' )
	Alter Table oktell_cc_temp.dbo.A_Sms
	Add IdServer nvarchar ( 50 )
GO

if exists ( Select * from sysobjects where id = object_id ( 'dbo.A_Sms_AddReceived' ) )
	drop procedure dbo.A_Sms_AddReceived
GO

Create procedure dbo.A_Sms_AddReceived
--	@idguid uniqueidentifier,
	@dt datetime,
	@sender nvarchar ( 100 ),
	@receiver nvarchar ( 100 ),
	@smstext nvarchar ( 4000 ),
	@idserver nvarchar ( 50 ) = '',
	@idout int OUTPUT
as
begin
	Insert into oktell_cc_temp.dbo.A_Sms
	( 
		--IdGuid, 
		Received, DT, Sender, Receiver, SmsText )
	Values
	( 	--@idguid, 
		1, @dt, @sender, @receiver, @smstext )

	select @idout = cast ( @@identity as int )
end
GO
