if exists ( Select * FROM sysobjects Where id = object_Id ( 'dbo.A_Settings_LoadOne' ))
	Drop procedure dbo.A_Settings_LoadOne
GO

Create Procedure [dbo].[A_Settings_LoadOne]
	@name nvarchar ( 50 )
as
begin
	Select * 
	From A_Settings
	Where [Name] like @name
end
GO


if exists ( Select * FROM sysobjects Where id = object_Id ( 'dbo.A_Settings_SaveOne' ))
	Drop procedure dbo.A_Settings_SaveOne
GO

Create Procedure [dbo].[A_Settings_SaveOne]
	@name nvarchar ( 255 ),
	@valstr nvarchar ( 4000 ) = null,
	@valint int = null,
	@valdouble float = null,
	@valdt datetime = null
as
begin
	Update A_Settings
	Set 	valuestr = @valstr, 
		valueint = @valint,
		valuedouble = @valdouble,
		valuedatetime = @valdt
	Where [Name] like @name

	if ( @@rowcount = 0 )
		Insert 
		Into A_Settings ( [Name], ValueStr, ValueInt, ValueDouble, ValueDateTime )
		Values ( @name, @valstr, @valint, @valdouble, @valdt )
end
GO